/*
** Module   : MenuDefinition.java
** Abstract : An abstract class. Its implementation will described concrete menu definition. 
**
** Copyright (c) 2014, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- ---------------------------------Description---------------------------------
** 001 VIG 20141114 Created initial version.
*/
package com.goldencode.p2j.ui;

import java.lang.reflect.*;

/**
 * Base class for menu definitions. One implementation for each menu.
 */
public abstract class MenuDefinition
implements InvocationHandler
{
   /**
    * Sets the menu up.
    * 
    * @param  menu
    *         instance of <code>MenuWidget</code>
    */
   public abstract void setup(MenuWidget menu);

   /**
    * This method acts as an interceptor which is called every time a
    * method of the proxy object is invoked. It allows us to perform pre-
    * and post-processing for these methods, and to delegate the regular
    * work of the method to the backing implementation DMO.
    *
    * @param   proxy
    *          Proxy object upon which the intercepted method is invoked.
    * @param   method
    *          Method to be invoked through reflection.
    * @param   args
    *          Arguments, if any, to <code>method</code>.
    *
    * @return  value returned from the invoked method. 
    * 
    * @throws  Throwable
    *          if an exception/error occurs upon the invocation target,
    *          or if any problem occurs during pre- or post-processing.
    */
   @Override
   public Object invoke(Object proxy, Method method, Object[] args)
   throws Throwable
   {
      // TODO how to implement it?
      return null;
   }
}
